#!perl 

use Mac::Windows;
use Mac::QuickDraw;
use Mac::Events;
use Mac::Controls;
use Mac::Lists;
use Mac::AppleEvents;
use Mac::Processes;
use Mac::MoreFiles;

use strict;
use vars qw($v $OK);

$|=1;

#------------------------------------ wake up 'GraphicConverter' ------------------------------------

launch_gc();

#------------------------------------------ where are we? -------------------------------------------

chomp( $v->{cwd} = `pwd`);

#---------------------------------------- area for pictures -----------------------------------------

$v->{clear} = new Rect(252, 22, 378, 138);

#------------------------------------------ get list data -------------------------------------------

opendir DIR, ':graphics' or die "$!\n";
foreach (readdir(DIR)) { push(@{$v->{data}}, $_) }
close DIR;

#---------------------------------------------- window ----------------------------------------------

$v->{frame} = new Rect(16, 52, 416, 252);
$v->{win} = MacColorWindow->new($v->{frame}, "ListWindow", 1, 4, 1);
SetPort $v->{win}->window;
RGBBackColor(new RGBColor(56818, 56818, 56818));
$v->{win}->sethook('drawgrowicon', sub { 1 });
$v->{win}->sethook('goaway', sub { TrackGoAway($_[0]->{port}, $_[1]); $OK = 1 });
$v->{win}->sethook('redraw', \&draw_lines);

#--------------------------------------------- buttons ----------------------------------------------

$v->{b_1} = $v->{win}->new_control(Rect->new(310, 160, 380, 180), 'FETCH', 1, 0, 0, 1, 35, 1);
$v->{b_1}->sethook('hit', \&button_ID1);

#----------------------------------------------- list -----------------------------------------------

$v->{t_col} = RGBColor->new(65535, 0, 0);
$v->{whi} = RGBColor->new(0xffff, 0xffff, 0xffff);
$v->{fontsize} = 10;

$v->{l_r} = Rect->new(22, 22, 213, 139);
$v->{l_size} = Rect->new(0, 0, 1, scalar @{$v->{data}});
$v->{cell} = Point->new(340, int(1.9*$v->{fontsize})+1);
$v->{l_1} = $v->{win}->new_list($v->{l_r}, $v->{l_size}, $v->{cell}, \&MyLDEF, 1, 1);

$v->{l_1}->{list}->indent(Point->new(10, 1+int(1.3*$v->{fontsize})));

for (0..$#{$v->{data}}) {
    $v->{l_1}->set(0, $_, ${$v->{data}}[$_])
}

$v->{l_1}->{list}->selFlags(lOnlyOne+lUseSense);
$v->{l_1}->sethook('hit', \&list_1);
LSetSelect 1, Point->new(0, 0), $v->{l_1}->{list};

#----------------------------------------- Wait Next Event ------------------------------------------

while ($v->{win}->window and !$OK) { WaitNextEvent };

#--------------------------------------------- cleanup ----------------------------------------------

$v->{win}->dispose;
DisposeControl $v->{b_1}->{control} if defined $v->{b_1}->{control};
LDispose $v->{l_1}->{list} if defined $v->{l_1}->{list};
AEDisposeDesc $v->{evt} if defined $v->{evt};
AEDisposeDesc $v->{rep} if defined $v->{rep};
KillPicture $v->{pict} if defined $v->{pict};
unlink "$ENV{TMPDIR}:temp.pict";

#--------------------------------------------- handlers ---------------------------------------------

sub button_ID1 {
	my $cell = Point->new(0, 0);
    while ($cell) {
	    $cell = LGetSelect(1, $cell, $v->{l_1}->{list});
        if (defined $cell) {
        	my $data = LGetCell $cell, $v->{l_1}->{list};
        	show_picture($data)
        }
        else { last }
        $cell->v($cell->v+1) if defined $cell;
    }
}

sub list_1 {
   my ($list, $win) = @_;
   my $cell = LGetSelect(1, Point->new(0, 0), $list->{list});
   my $data = LGetCell($cell, $list->{list}) if defined $cell;
   show_picture($data)
}

#--------------------------------------------- routines ---------------------------------------------

sub draw_lines {
    my $blk = GetForeColor;

    # panel
    RGBForeColor(RGBColor->new(53.3*655.35, 53.3*655.35, 53.3*655.35));
    MoveTo 20, 140; LineTo 20, 20; LineTo 230, 20;
    MoveTo 250, 140; LineTo 250, 20; LineTo 380, 20;
    RGBForeColor(RGBColor->new(100*655.35, 100*655.35, 100*655.35));
    MoveTo 20, 140; LineTo 230, 140; LineTo 230, 20;
    MoveTo 250, 140; LineTo 380, 140; LineTo 380, 20;

    RGBForeColor $blk;
    
    if (defined $v->{pict}) {
    	my $rect = $v->{pict}->picFrame;
		$rect->top(0);
		$rect->left(0);

   	 	DrawPicture($v->{pict}, OffsetRect($rect, 315-($rect->right/2), 80-($rect->bottom/2)));
   	 }

}

sub MyLDEF {
    my($msg, $select, $rect, $cell, $data, $list) = @_;
    my $fore = GetForeColor;

    return unless $msg == lDrawMsg || $msg == lHiliteMsg;

    my($where) = AddPt($rect->topLeft, $list->indent);
    EraseRect $rect;
   
    TextFont(3);
    TextSize($v->{fontsize});

    if ($select) {
        RGBForeColor($v->{t_col});
        TextFace(bold);
    }
    else {
        TextFace(normal);
    }

    MoveTo($where->h, $where->v);
    DrawString $data;
    MoveTo($rect->left, $rect->bottom-1);
    RGBForeColor($v->{whi}); Line($v->{l_r}->right, 0);
 
    RGBForeColor($fore);
}

sub show_picture {
    my ($pic) = @_;
    
    $pic = $v->{cwd}.':graphics:'.$pic;
    if ($pic !~ /\.pict$/) { convert_picture($pic); $v->{draw} = "$ENV{TMPDIR}:temp.pict" }
    else { $v->{draw} = $pic }

	$v->{pict} = '';
    open IMG, $v->{draw} or die "$!\n";
	$v->{pict} = PicHandle->new(substr join('', <IMG>), 512);
	close IMG;
	
	my $rect = $v->{pict}->picFrame;
	$rect->top(0);
	$rect->left(0);
    
    EraseRect $v->{clear};
	DrawPicture($v->{pict}, OffsetRect($rect, 315-($rect->right/2), 80-($rect->bottom/2)));
} 

sub convert_picture {
	my($source) = @_;
	
	if (! -f "$ENV{TMPDIR}:temp.pict") { open PICT, "+>$ENV{TMPDIR}:temp.pict" }

	my $target = "$ENV{TMPDIR}:temp.pict";
	
	$v->{evt} = AEBuildAppleEvent(
		'gcSt','xCnf', 'sign', 'GKON', 0, 0,
		qq(
			kysc:TEXT(\@),
			kytg:TEXT(\@),
			kywf:1
		 ), $source, $target
	) or die $^E;
	$v->{rep} = AESend($v->{evt}, kAEWaitReply) or die $^E;
}


sub launch_gc {
my ($running, $psn, $Launch, $evt, $rep);
	
    foreach $psn (keys %Process) {
		if ($Process{$psn}->processSignature eq 'GKON') {
			$running = 1;
			last
		}
	}
		
	if (!$running) {
		$Launch = new LaunchParam(
			launchControlFlags => launchContinue+launchNoFileFlags+launchDontSwitch,
			launchAppSpec      => $Application{GKON}
		);
		
		LaunchApplication($Launch) ordie "$^E";
	}

    my $q = 1;
    my $m;
    
    foreach $psn (keys %Process) {
        if ($Process{$psn}->processSignature eq 'GKON') {
            $m = $Process{$psn}->processName;
            last;
        }
    }
    
    my $obj = "obj {form:prop, 
					want:type(prop), 
					seld:type(pvis), 
					from:obj {form:name, 
							  want:type(prcs), 
							  seld:TEXT(@), 
							  from:'null'()
							 }
					}";
					
    my $set = AEBuildAppleEvent('core', 'setd', 'sign', 'MACS', 0, 0, qq('----': $obj, data:fals), $m);
    my $error = 1;
    my $i = 0;
    
	while ($error and $i<50) { 
        $rep = AESend($set, kAEWaitReply);
        $error = AEGetParamDesc($rep, 'errn');
        select undef, undef, undef, 0.2;
        $i++;
    }
    
   if ($i>=50) {
       print "Cannot hide GraphicConverter\n";
       print "Please try again\n";
       exit;
   }
        
    AEDisposeDesc $set   if $set;
    AEDisposeDesc $rep   if $rep;
    AEDisposeDesc $error if $error;
}
